import 'package:senior_platform_authentication/senior_platform_authentication.dart';

import '../../data/repositories/secure_storage_repository.dart';
import '../entities/user_name.dart';

class GetStoredUserUsecase implements BaseUsecase<User?, UserName> {
  late final SecureStorageRepository _secureStorageRepository;

  GetStoredUserUsecase({
    SecureStorageRepository? secureStorageRepository,
  }) {
    _secureStorageRepository =
        secureStorageRepository ?? SecureStorageRepositoryImpl();
  }

  @override
  Future<User?> call(UserName username) async {
    final currentUsername = username.currentUsername?.isEmpty ?? true
        ? await _secureStorageRepository.readLastUser() ?? ''
        : username.currentUsername!;
    return await _secureStorageRepository.readUser(
      username: currentUsername,
    );
  }
}
