part of 'authentication_bloc.dart';

abstract class AuthenticationEvent extends Equatable {
  const AuthenticationEvent();
}

class AuthenticationStatusChanged extends AuthenticationEvent {
  final AuthenticationStatus status;
  final AuthenticationResponse? authenticationResponse;

  const AuthenticationStatusChanged(this.status, {this.authenticationResponse});

  @override
  List<Object?> get props => [
        status,
        authenticationResponse,
      ];
}

class LogoutOnlineRequested extends AuthenticationEvent {
  const LogoutOnlineRequested();

  @override
  List<Object?> get props => [];
}

class LogoutOfflineRequested extends AuthenticationEvent {
  final String username;
  final bool eraseToken;

  const LogoutOfflineRequested({
    required this.username,
    this.eraseToken = false,
  });

  @override
  List<Object?> get props => [
        username,
        eraseToken,
      ];
}

class CheckAuthenticationRequested extends AuthenticationEvent {
  final String? username;

  const CheckAuthenticationRequested({
    this.username,
  });

  @override
  List<Object?> get props => [
        username,
      ];
}
